#include <stdio.h>
#include <string.h>
#include "PictInfo.h"

void FPrint(char * it)
{
	char buf[256];
	Ptr where;
	
	sprintf(buf, "%s", it);
	
	while(where = strstr(buf,"\n"))
		*where = '\r';
	fprintf(dumpFile,buf);
}

long elementCount = 0;
long groupCount = 0;
long maxGroupCount = 0;

void GroupLevel(short direction)
{
	groupCount+=direction;
	printf("  Group Level = %d",groupCount);
	fprintf(dumpFile,"  Group Level = %d",groupCount);
	
	if (maxGroupCount<groupCount)
		maxGroupCount=groupCount;
}

void ElementCount(void)
{
	elementCount ++;
	printf("%5ld: ",elementCount);
	fprintf(dumpFile,"%5ld: ",elementCount);
}

void ElementPad(void)
{
	PRINTF("                                 ");
}


void myPictInfo(PicHandle thePict)
{
	PictInfo	theInfo;

	short myErr = GetPictInfo(thePict,&theInfo,returnPalette + recordComments,1,systemMethod,0);
	
	printf("  Pict Info Version : %d\n",theInfo.version);
	printf("  Pict HRes         : %d\n",theInfo.hRes>>16);
	printf("  Pict VRes         : %d\n",theInfo.vRes>>16);
	printf("  textCount         : %d\n",theInfo.textCount);
	printf("  lineCount         : %d\n",theInfo.lineCount);
	printf("  rectCount         : %d\n",theInfo.rectCount);
	printf("  rRectCount        : %d\n",theInfo.rRectCount);
	printf("  ovalCount         : %d\n",theInfo.ovalCount);
	printf("  arcCount          : %d\n",theInfo.arcCount);
	printf("  polyCount         : %d\n",theInfo.polyCount);
	printf("  regionCount       : %d\n",theInfo.regionCount);
	printf("  bitMapCount       : %d\n",theInfo.bitMapCount);
	printf("  pixMapCount       : %d\n",theInfo.pixMapCount);
	
	printf("  commentCount      : %d\n",theInfo.commentCount);
	printf("  uniqueComments    : %d\n",theInfo.uniqueComments);
	printf("  uniqueFonts       : %d\n",theInfo.uniqueFonts);
	printf("***  \n");

	fprintf(dumpFile,"  Pict Info Version : %d\n",theInfo.version);
	fprintf(dumpFile,"  Pict HRes         : %d\n",theInfo.hRes>>16);
	fprintf(dumpFile,"  Pict VRes         : %d\n",theInfo.vRes>>16);
	fprintf(dumpFile,"  textCount         : %d\n",theInfo.textCount);
	fprintf(dumpFile,"  lineCount         : %d\n",theInfo.lineCount);
	fprintf(dumpFile,"  rectCount         : %d\n",theInfo.rectCount);
	fprintf(dumpFile,"  rRectCount        : %d\n",theInfo.rRectCount);
	fprintf(dumpFile,"  ovalCount         : %d\n",theInfo.ovalCount);
	fprintf(dumpFile,"  arcCount          : %d\n",theInfo.arcCount);
	fprintf(dumpFile,"  polyCount         : %d\n",theInfo.polyCount);
	fprintf(dumpFile,"  regionCount       : %d\n",theInfo.regionCount);
	fprintf(dumpFile,"  bitMapCount       : %d\n",theInfo.bitMapCount);
	fprintf(dumpFile,"  pixMapCount       : %d\n",theInfo.pixMapCount);
	
	fprintf(dumpFile,"  commentCount      : %d\n",theInfo.commentCount);
	fprintf(dumpFile,"  uniqueComments    : %d\n",theInfo.uniqueComments);
	fprintf(dumpFile,"  uniqueFonts       : %d\n",theInfo.uniqueFonts);
	fprintf(dumpFile,"***  \n");
	
	long count = GetHandleSize(Handle(theInfo.commentHandle)) / sizeof(CommentSpec);
	
	for (short i=0;i<count;i++)
	{
		CommentSpecPtr	where = CommentSpecPtr(*theInfo.commentHandle);
		where +=i;
		printf(" "); 
		fprintf(dumpFile," "); 
		IDComment(where->ID);
		printf(" : %4d,   count : %4d\n", where->ID, where->count);
		fprintf(dumpFile," : %4d,   count : %4d\n", where->ID, where->count);
	}

	printf("***  \n");
}

void IDComment(short who)
{
	ElementCount();
	PRINTF("Comment: ");
	switch (who)
	{
		case 100:
			PRINTF("AppComment       ");
			break;
			
		case 130:
			PRINTF("DrawBegin        ");
			break;
		case 131:
			PRINTF("DrawEnd          ");
			break;
			
		case 140:
			PRINTF("GroupBegin       ");
			GroupLevel(+1);
			break;
		case 141:
			PRINTF("GroupEnd         ");
			GroupLevel(-1);
			break;
		case 142:
			PRINTF("BitBegin         ");
			break;
		case 143:
			PRINTF("BitEnd           ");
			break;
			
		case 150:
			PRINTF("TextBegin        ");
			break;
		case 151:
			PRINTF("TextEnd          ");
			break;
		case 152:
			PRINTF("StringBegin      ");
			break;
		case 153:
			PRINTF("StringEnd        ");
			break;
		case 154:
			PRINTF("TextCenter       ");
			break;
		case 155:
			PRINTF("TextCenter       ");
			break;
		case 156:
			PRINTF("TextCenter       ");
			break;
		case 157:
			PRINTF("TextCenter       ");
			break;
			
		case 160:
			PRINTF("PolyBegin        ");
			break;
		case 161:
			PRINTF("PolyEnd          ");
			break;
		case 162:
			PRINTF("PolyBytes        ");
			break;
		case 163:
			PRINTF("PolyIgnore       ");
			break;
		case 164:
			PRINTF("PolySmooth       ");
			break;
		case 165:
			PRINTF("PolyClose        ");
			break;

		case 170:
			PRINTF("Arrow1           ");
			break;
		case 171:
			PRINTF("Arrow2           ");
			break;
		case 172:
			PRINTF("Arrow3           ");
			break;
		case 173:
			PRINTF("ArrowEnd         ");
			break;

		case 180:
			PRINTF("DashBegin        ");
			break;
		case 181:
			PRINTF("DashEnd          ");
			break;

		case 182:
			PRINTF("LineWidth        ");
			break;

		case 190:
			PRINTF("PostBegin        ");
			break;
		case 191:
			PRINTF("PostEnd          ");
			break;
		case 192:
			PRINTF("PostScriptHandle ");
			break;
		case 193:
			PRINTF("PostScriptFile   ");
			break;
		case 194:
			PRINTF("TextIsPostScript ");
			break;
		case 195:
			PRINTF("ResourcePS       ");
			break;
		case 196:
			PRINTF("PSBegin          ");
			break;
		case 197:
			PRINTF("PostScriptHandle ");
			break;

		case 200:
			PRINTF("RotateBegin      ");
			break;
		case 201:
			PRINTF("RotateEnd        ");
			break;
		case 202:
			PRINTF("RotateCenter     ");
			break;

		case 214:
			PRINTF("AutoNap          ");
			break;

		case 215:
			PRINTF("AutoWake         ");
			break;
			
		case 216:
			PRINTF("ManualNap        ");
			break;

		case 217:
			PRINTF("ManualWake       ");
			break;
			
		default:
			PRINTF("UNKNOWN!!!       ");
			break;

	}
}
