// pict dumping tool
// by Greg Ames
// Ames & Associates
// all rights reserved
// copyright 1997
//
// for NASA FEAT Project
// debugging tool
// greg@acc44.com
//
//

#include <stdio.h>
#include "PictInfo.h"
#include "SIOUX.h"

#define PICTHEADER	512

WindowPtr	pCWindow;
FILE * dumpFile;

void MungProcs(void);

void main(void)
{

	SIOUXSettings.asktosaveonclose = false;
	SIOUXSettings.initializeTB = false;

	InitGraf(&qd.thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(nil);
	InitCursor();
	


	SFReply	theReply;
	Point	where = {100,100};
	SFTypeList	typeList= {'PICT','xxxx','xxxx','xxxx'};
	theReply.good = true;
	while (theReply.good)
	{

	SFGetFile(where,"\p",0L,1,typeList,0L,&theReply);
	if (theReply.good)
	{
		short	theRef;
		char	what[256];
		long 	curEOF;
		OSErr	err;
		PicHandle theImage;
		char	fileName[256];
		
		err = FSOpen(theReply.fName, theReply.vRefNum, &theRef);
		theReply.fName[theReply.fName[0]+1] = 0;
		printf("Dumping : %s\n",&theReply.fName[1] );
		fprintf(dumpFile,"Dumping : %s\n",&theReply.fName[1] );
		err = GetEOF(theRef,&curEOF);
		printf("Size : %ld\n\n",curEOF );
		fprintf(dumpFile,"Size : %ld\n\n",curEOF );

		err = SetFPos(theRef,fsFromStart, PICTHEADER );
		
		pCWindow = GetNewCWindow(128, 0L,WindowPtr(-1L));
		
		curEOF-=PICTHEADER;
		
		theImage = PicHandle(NewHandle(curEOF));
		
		err = FSRead(theRef,&curEOF, *theImage );

		err = FSClose(theRef);
		
		err = SetVol("\p",theReply.vRefNum);
		
		sprintf(fileName, "%s.dump",&theReply.fName[1]);
		
		dumpFile = fopen(fileName,"w");
		
		
		Rect	r = (*theImage)->picFrame;
		
		OffsetRect(&r,-r.left,-r.top);
		
		SizeWindow(pCWindow,r.right, r.bottom,true);
//		ShowWindow(pCWindow);
		SetPort(pCWindow);
		MungProcs();
		

		PRINTF("### Top\n");
		myPictInfo(theImage);
		PRINTF("\n\n********************************\n");
		
		elementCount = 0;
		groupCount = 0;
		maxGroupCount = 0;
		
		DrawPicture(theImage, &r);
		PRINTF("### Bottom\n");

		printf("Maximum Group Level : %d\n",maxGroupCount );
		fprintf(dumpFile,"Maximum Group Level : %d\n",maxGroupCount );
		
		printf("Done with : %s\n",&theReply.fName[1] );
		fprintf(dumpFile,"Done with : %s\n",&theReply.fName[1] );

		SysBeep(1);
//		while (!Button());
		HideWindow(pCWindow);
		fclose(dumpFile);
	}
	}// while theReply.good
}
CQDProcs	myProcs;
CQDProcs	oldProcs;

void test123(void );

pascal void 	myQDTextProc(short byteCnt , Ptr TextAddr, Point numerPt, Point denomPt);
pascal void 	myQDStdLine(Point endPoint);
pascal void 	myQDRect(GrafVerb gVerb, Rect &theRect);
pascal void 	myQDRRect(GrafVerb gVerb, Rect &theRect, short ovalWidth, short ovalHeight);
pascal void 	myQDStdOval(GrafVerb gVerb, Rect &theRect);
pascal void 	myStdArc(GrafVerb gVerb, Rect &theRect, short startAngle, short arcAngle);
pascal void 	myStdPoly(GrafVerb gVerb,PolyHandle thePoly);
pascal void 	myStdRgn(GrafVerb gVerb,PolyHandle theRgn);
pascal void 	myStdBits(BitMap &srcMap,Rect &srcRect,Rect &destRect,short tMode,RgnHandle maskRgn);
pascal void 	myStdComment(short dataKind,short dataSize,Handle dataHandle);
pascal short 	myStdTxMeas(short byteCnt,Ptr textAddr,Point &numer,Point &denom,FontInfo &fInfo);
pascal void 	myStdGetPic(Ptr destPtr,short byteCnt);
pascal void 	myStdPutPic(Ptr srcPtr,short byteCnt);
pascal void 	myOpcode(Rect *fromRect, Rect *toRect, short opcode, short version);

QDTextUPP 	theQDTextProcUPP 	= NewQDTextProc(	myQDTextProc	);
QDLineUPP 	theQDLineProcUPP 	= NewQDLineProc(	myQDStdLine		);
QDRectUPP 	theQDRectUPP 		= NewQDRectProc(	myQDRect		);
QDRRectUPP 	theQDRRectUPP 		= NewQDRRectProc(	myQDRRect		);
QDOvalUPP 	theQDOvalUPP 		= NewQDOvalProc(	myQDStdOval		);
QDArcUPP 	theQDArcUPP			= NewQDArcProc(		myStdArc		);
QDPolyUPP 	theQDPolyUPP		= NewQDPolyProc(	myStdPoly		);

QDRgnUPP	theQDRgnUPP 		= NewQDRgnProc(		myStdRgn		);
QDBitsUPP	theQDBitsUPP 		= NewQDBitsProc(	myStdBits		);
QDCommentUPP theQDCommentUPP 	= NewQDCommentProc(	myStdComment	);
QDTxMeasUPP	theQDTxMeasUPP		= NewQDTxMeasProc(	myStdTxMeas		);
QDGetPicUPP	theQDGetPicUPP		= NewQDGetPicProc(	myStdGetPic		);
QDPutPicUPP	theQDPutPicUPP		= NewQDPutPicProc(	myStdPutPic		);

QDOpcodeUPP theQDOpcodeUPP 		= NewQDOpcodeProc(	myOpcode		);


void MungProcs()
{
//	SetStdCProcs(&oldProcs);
	SetStdCProcs(&myProcs);
	pCWindow->grafProcs	= (QDProcs *)&myProcs;
	myProcs.textProc	= 	theQDTextProcUPP;
	myProcs.lineProc	= 	theQDLineProcUPP;
	myProcs.rectProc	= 	theQDRectUPP;
	myProcs.rRectProc	= 	theQDRRectUPP;
	
	myProcs.ovalProc	= 	theQDOvalUPP;
	myProcs.arcProc		=	theQDArcUPP;

	myProcs.polyProc	=	theQDPolyUPP;
	myProcs.rgnProc		=	theQDRgnUPP;
	myProcs.bitsProc	=	theQDBitsUPP;
	myProcs.commentProc	=	theQDCommentUPP;
	myProcs.txMeasProc	=	theQDTxMeasUPP;
//	myProcs.getPicProc	=	theQDGetPicUPP;
//	myProcs.putPicProc	=	theQDPutPicUPP;
//	myProcs.opcodeProc	= 	theQDOpcodeUPP;
}
pascal 
void myQDTextProc(short byteCnt , Ptr TextAddr, Point numerPt, Point denomPt)
{
	ElementCount();
	char buffer[1024];
	if (byteCnt<1023)
	{
		BlockMoveData(TextAddr,buffer,byteCnt);
		buffer[byteCnt] = 0;
		printf("Text   :                    %s\n",buffer);
		fprintf(dumpFile,"Text   :                    %s\n",buffer);
	}
	else
	{
		BlockMoveData(TextAddr,buffer,1023);
		buffer[1023] = 0;
		printf("Text (too big!!!):          %s\n",buffer);
		fprintf(dumpFile,"Text (too big!!!):          %s\n",buffer);
	}
}

pascal void myQDStdLine(Point endPoint)
{
	ElementCount();
	printf(          "Line   :                    v = %d  h = %d\n",endPoint.v,endPoint.h);
	fprintf(dumpFile,"Line      :                 v = %d  h = %d\n",endPoint.v,endPoint.h);
}

pascal void myQDRect(GrafVerb gVerb, Rect &theRect)
{
	ElementCount();
	printf("Rect   :                    left = %d  right = %d  top = %d  bottom = %d  width = %d  height = %d\n",
				   theRect.left,
				   theRect.right,
				   theRect.top,
				   theRect.bottom,
				   theRect.right - theRect.left,
				   theRect.bottom -theRect.top );
	fprintf(dumpFile,"Rect   :                    left = %d  right = %d  top = %d  bottom = %d  width = %d  height = %d\n",
				   theRect.left,
				   theRect.right,
				   theRect.top,
				   theRect.bottom,
				   theRect.right - theRect.left,
				   theRect.bottom -theRect.top );
	doVerb (gVerb);
}

pascal void myQDRRect(GrafVerb gVerb, Rect &theRect, short ovalWidth, short ovalHeight)
{
	ElementCount();
	printf("RRect     : left = %d  right = %d  top = %d  bottom = %d  width = %d  height = %d\n",
				   theRect.left,
				   theRect.right,
				   theRect.top,
				   theRect.bottom,
				   theRect.right - theRect.left,
				   theRect.bottom -theRect.top );
	fprintf(dumpFile,"RRect     : left = %d  right = %d  top = %d  bottom = %d  width = %d  height = %d\n",
				   theRect.left,
				   theRect.right,
				   theRect.top,
				   theRect.bottom,
				   theRect.right - theRect.left,
				   theRect.bottom -theRect.top );
	ElementPad();
	printf("  Oval width = %d  Oval Height = %d\n",ovalWidth,ovalHeight);
	fprintf(dumpFile,"  Oval width = %d  Oval Height = %d\n",ovalWidth,ovalHeight);
	doVerb (gVerb);
}

pascal void myQDStdOval(GrafVerb gVerb,Rect &theRect)
{
	ElementCount();
	PRINTF("Oval     :                  ");
	doRect(theRect);
	doVerb (gVerb);
}

pascal void myStdArc(GrafVerb gVerb, Rect &theRect, short startAngle, short arcAngle)
{
	ElementCount();
	PRINTF("Arc      :                  ");
	doRect(theRect);
	doVerb (gVerb);
	ElementPad();
	printf("  Start : %d  Angle : %d", startAngle,  arcAngle);
	fprintf(dumpFile,"  Start : %d  Angle : %d", startAngle,  arcAngle);
}

void doRect(Rect &r)
{
	printf("left = %d  right = %d  top = %d  bottom = %d\n",
				   r.left,
				   r.right,
				   r.top,
				   r.bottom);
	fprintf(dumpFile,"left = %d  right = %d  top = %d  bottom = %d\n",
				   r.left,
				   r.right,
				   r.top,
				   r.bottom);
	ElementPad();
	printf("  width = %d  height = %d\n",
				   r.right 	- r.left,
				   r.bottom - r.top );
	fprintf(dumpFile,"  width = %d  height = %d\n",
				   r.right 	- r.left,
				   r.bottom - r.top );
}

void doVerb(short gVerb)
{
	ElementPad();
	switch (gVerb)
	{
		case 0:
			PRINTF("  Type  : frame\n");
			break;
		case 1:
			PRINTF("  Type  : paint\n");
			break;
		case 2:
			PRINTF("  Type  : erase\n");
			break;
		case 3:
			PRINTF("  Type  : invert\n");
			break;
		case 4:
			PRINTF("  Type  : fill\n");
			break;
		default:
			PRINTF("  Type  : unknown!!!\n");
			break;
	}
}

pascal void 	myStdPoly(GrafVerb gVerb,PolyHandle thePoly)
{
	ElementCount();
	PRINTF("Poly   :                    ");
//	ElementPad();
	doRect((*thePoly)->polyBBox);
	ElementPad();
	printf("  Poly Size : %d  points = %d\n", ((*thePoly)->polySize - 10)/4);
	fprintf(dumpFile,"  Poly Size : %d  points = %d\n", ((*thePoly)->polySize - 10)/4);
	doVerb(gVerb);
}

pascal void 	myStdRgn(GrafVerb gVerb,PolyHandle theRgn)
{
	ElementCount();
	PRINTF("Rgn      :                    ");
	doRect((*theRgn)->polyBBox);
	ElementPad();
	printf("  Poly Size : %d  points = %d",(*theRgn)->polySize,  ((*theRgn)->polySize - 10)/4);
	fprintf(dumpFile,"  Poly Size : %d  points = %d",(*theRgn)->polySize,  ((*theRgn)->polySize - 10)/4);
	doVerb(gVerb);
}

pascal void 	myStdBits(BitMap &srcMap, Rect &srcRect, Rect &destRect,short tMode,RgnHandle maskRgn)
{
	ElementCount();
	PRINTF("BitMap      :                    bitmapRect : ");
	doRect(srcMap.bounds);
	ElementPad();
	PRINTF("  srcRect : ");
	doRect(srcRect);
	ElementPad();
	PRINTF("  destRect : ");
	doRect(destRect);
	ElementPad();
	printf("  Transfer mode : %d\n", tMode);
	fprintf(dumpFile,"  Transfer mode : %d\n", tMode);
	ElementPad();
	PRINTF("  mask : ");
	if (maskRgn)	// only if there is a valid mask
	{
		doRect((*maskRgn)->rgnBBox);
		ElementPad();
		printf("  Rgn Size : %d\n", (*maskRgn)->rgnSize);
		fprintf(dumpFile,"  Rgn Size : %d\n", (*maskRgn)->rgnSize);
	}
}

pascal void 	myStdComment(short dataKind,short dataSize,Handle dataHandle)
{
	unsigned char buffer[1024];
	char hex[] = "0123456789ABCDEF";
	
	short count = dataSize;
	if (count>1023)
		count = 1023;
//	printf("Comment : ");
	IDComment(dataKind);
	printf("  opcode = %d  size = %d\n", dataKind, dataSize);
	fprintf(dumpFile,"  opcode = %d  size = %d\n", dataKind, dataSize);
	BlockMoveData(*dataHandle, buffer, count);
	buffer[count] = 0;
	if (dataSize>0)
	{
		ElementPad();
		printf("  data : %s",buffer);
		fprintf(dumpFile,"  data : %s",buffer);
	}
//	if (dataSize>32)
//		dataSize = 32;
		
	if (dataSize>0)
	{
		for (short i=0; i<count ; i++)
			{
			if ((i % 8) == 0)
			{
				PRINTF("\n");
				ElementPad();
//				PRINTF("  hex : ");
				printf("  %08x : ",i);
				fprintf(dumpFile,"  %08x : ",i);
			}
				printf("%c%c ",hex[buffer[i] /16],hex[buffer[i] % 16]);
				fprintf(dumpFile,"%c%c ",hex[buffer[i] /16],hex[buffer[i] % 16]);
			}
		PRINTF("\n");
	}
		
}

pascal short 	myStdTxMeas(short byteCnt, Ptr textAddr, Point &numer, Point &denom, FontInfo &fInfo)
{
	ElementCount();
	PRINTF("*** myStdTxMeas\n");
}

pascal void 	myStdGetPic(Ptr destPtr,short byteCnt)
{
	ElementCount();
	PRINTF("*** myStdGetPic\n");
}

pascal void 	myStdPutPic(Ptr srcPtr,short byteCnt)
{
	ElementCount();
	PRINTF("*** myStdPutPic\n");
}

pascal void 	myOpcode(Rect *fromRect, Rect *toRect, short opcode, short version)
{
	ElementCount();
	PRINTF("*** myOpcode\n");
}

